
//------------------------------------------------------------------------------
//         Defs
//------------------------------------------------------------------------------
#define ARM_MODE_SVC     0x13
#define I_BIT            0x80
#define F_BIT            0x40

//------------------------------------------------------------------------------
//         Startup routine
//------------------------------------------------------------------------------

            .align      4
            .arm
            .section    .text
            .global     entry

entry:

//Perform low-level initialization of the chip using AT91F_LowLevelInit()
        ldr     sp, =_sstack
	    ldr     r0, =AT91F_LowLevelInit
        mov     lr, pc
        bx      r0

//Clear the zero segment
	    ldr     r0, =_szero
        ldr     r1, =_ezero
        mov     r2, #0			//value to be written (=0)
1:
        cmp     r0, r1
        strcc   r2, [r0], #4
        bcc     1b	//1b = one label backwards

//set supervisor mode with I and F bits masked
        msr     CPSR_c, #ARM_MODE_SVC | I_BIT | F_BIT	//back to supervisor mode, FIQ still masked

//setup stack
        ldr     sp, =_sstack							//sp = _sstack (see .lds file)

//Branch to main()
        ldr     r0, =main	//load address of main to r0
        mov     lr, pc		//move value in PC into link register
        bx      r0			//branch to main

//Loop indefinitely when program is finished
1:
        b       1b

