#ifndef __XMODEM_H__
#define __XMODEM_H__


#define XMODEM_PAYLOAD_LENGTH		128


#define SOH		1		//start of heading
#define EOT		4		//end of transfer
#define ACK		6		//acknowledge
#define NAK		21		//negative acknowledge
#define CAN		24		//cancel


typedef struct __attribute__((packed)) {
	uint8_t startByte;
	uint8_t packetNumber;
	uint8_t notPacketNumber;
	uint8_t payload[XMODEM_PAYLOAD_LENGTH];
	uint16_t checksum;
}TXmodemBlock;



uint16_t xmodemDownloadBlock(TXmodemBlock *pBlock);


#endif

