#ifndef __FS_TOOLS__
#define __FS_TOOLS__

#include "common.h"
#include "ff.h"

#define F_LSEEK_EOF				0xFFFFFFFF
#define FS_FILE_PRESENT			0
#define FS_NO_FILE				FR_NO_FILE



//high-level, provide only filename
FRESULT fsRemove(char* path);
FRESULT fsMkDir(char* dirPath);
void fsListFiles(char *dirPath);
FRESULT fsGetFileSize(char* fileName, uint32_t *size);
FRESULT fsRewrite(char* fileName, void* buf, uint16_t len);
uint16_t fsRead(char* fileName, void* buf, uint32_t pos, uint16_t len);
inline FRESULT fsAppend(char* fileName, void* buf, uint16_t len);
inline FRESULT fsWriteLine(char* fileName, char* buf);
FRESULT fsRemoveBytes(char* fileName, uint32_t bytes);
FRESULT fsReplace(char* fileName, void* buf, uint32_t pos, uint16_t len);
uint8_t fsFilePresent(char* fileName);
uint16_t fsListAllFiles(const char *dirName, char *buffer, uint8_t pathLen, uint16_t maxItems, char *extFilter);
uint8_t fsFindFreeFileName(const char *base, const char *ext, char *outputName);


//debug
void fsDispFRESULT(FRESULT res);
void fsDispFileInfo(FILINFO *finfo, char* buf);

//init
FRESULT fsInit(void);


#endif

