#ifndef __BOARD_H__
#define __BOARD_H__

//include standard headers for SAM9260
#include "include/AT91SAM9260.h"		//from Atmel
#include "include/lib_AT91SAM9260.h" 	//unofficial one (only few functions)

//global defs
#define EXT_OC          18432000  // External Oscillator frequency
#define MCK             (99328000)  // MCK, master clock for peripherals
#define PPLACK          198656000  // Clock for ARM core

#define USE_PERIPHERALS	0

#if USE_PERIPHERALS

//LEDS
#define LED_R_PIO		AT91C_BASE_PIOB
#define LED_R_MASK		AT91C_PIO_PB8
#define LED_G_PIO		AT91C_BASE_PIOA
#define LED_G_MASK		AT91C_PIO_PA6
#define LED_Y_PIO		AT91C_BASE_PIOA
#define LED_Y_MASK		AT91C_PIO_PA9
#define LED_B_PIO		AT91C_BASE_PIOB
#define LED_B_MASK		AT91C_PIO_PB9

//interface defs -- to be used in the program

#define LED_R_ON		LED_R_PIO->PIO_SODR = LED_R_MASK
#define LED_R_OFF		LED_R_PIO->PIO_CODR = LED_R_MASK
#define LED_R_TOGGLE	LED_R_PIO->PIO_ODSR ^= LED_R_MASK
#define LED_Y_ON		LED_Y_PIO->PIO_SODR = LED_Y_MASK
#define LED_Y_OFF		LED_Y_PIO->PIO_CODR = LED_Y_MASK
#define LED_Y_TOGGLE	LED_Y_PIO->PIO_ODSR ^= LED_Y_MASK
#define LED_B_ON		LED_B_PIO->PIO_SODR = LED_B_MASK
#define LED_B_OFF		LED_B_PIO->PIO_CODR = LED_B_MASK
#define LED_B_TOGGLE	LED_B_PIO->PIO_ODSR ^= LED_B_MASK
#define LED_G_ON		LED_G_PIO->PIO_SODR = LED_G_MASK
#define LED_G_OFF		LED_G_PIO->PIO_CODR = LED_G_MASK
#define LED_G_TOGGLE	LED_G_PIO->PIO_ODSR ^= LED_G_MASK

#else	//#if USE_PERIPHERALS

#define LED_R_TOGGLE	asm volatile("swi 0x1001")
#define LED_G_TOGGLE	asm volatile("swi 0x1002")
#define LED_Y_TOGGLE	asm volatile("swi 0x1003")
#define LED_B_TOGGLE	asm volatile("swi 0x1004")

#endif	//#if USE_PERIPHERALS

#endif
