#ifndef __DECK_TASK_H__
#define __DECK_TASK_H__

#include "id3.h"

enum {
	DECK_CMD_NOP = 0,
	DECK_CMD_START_PLAYBACK = 1,	//requires fileName as parameter
	DECK_CMD_STOP_PLAYBACK = 2,
	DECK_CMD_PAUSE = 3,
	DECK_CMD_FASTFORWARD = 4,
	DECK_CMD_REWIND = 5,
	DECK_CMD_REPORT = 6,
	DECK_CMD_START_RECORD = 7,
	DECK_CMD_STOP_RECORD = 8,	//requires fileName as parameter
	
	DECK_STA_OK = 0,
	DECK_STA_END_OF_TRACK = 1,
	DECK_STA_ERROR = 2,
	DECK_STA_INFO = 3,
	
	DECKTASK_STATE_IDLE = 0,
	DECKTASK_STATE_RECORD_WAVE = 1,
	DECKTASK_STATE_PLAY_WAVE = 2,
	DECKTASK_STATE_PLAY_MP3 =3,
};

enum {
	DECK_CORE_OK = 0,
	DECK_CORE_END_OF_TRACK = 1,
	DECK_CORE_DECODE_ERROR = 2,
	DECK_CORE_UNDERFLOW = 3,
	DECK_CORE_SYNC_ERROR = 4,
	DECK_CORE_DAC_UNDERRUN = 5,
	DECK_CORE_ERROR = 6,
	DECK_CORE_ADC_UNDERRUN = 7,
};


typedef struct {
	uint32_t command;
	char fileName[40];
}T_DeckCommand;

typedef struct {
	uint32_t status;
	uint32_t parameter;
}T_DeckStatus;

typedef struct {
	uint32_t deckTaskState;
	uint32_t totalBytes;
	uint32_t currentByte;
	uint32_t sampleRate;
}T_TrackInfo;


void deckPassQueueHandlers(xQueueHandle* pCommandQueue, xQueueHandle* pStatusQueue, xQueueHandle* pTrackInfoQueue);
uint8_t deckInit(void);

#endif

